package dev.shadowsoffire.apotheosis.ench;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import dev.shadowsoffire.apotheosis.Apoth;
import dev.shadowsoffire.apotheosis.ench.Ench;
import dev.shadowsoffire.apotheosis.ench.EnchConfig;
import dev.shadowsoffire.apotheosis.ench.EnchModule;
import dev.shadowsoffire.apotheosis.ench.EnchantmentInfo;
import dev.shadowsoffire.apotheosis.ench.api.IEnchantingBlock;
import dev.shadowsoffire.apotheosis.ench.table.EnchantingStatRegistry;
import dev.shadowsoffire.apotheosis.util.DrawsOnLeft;
import dev.shadowsoffire.placebo.util.EnchantmentUtils;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import net.minecraft.ChatFormatting;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.screens.MenuScreens;
import net.minecraft.client.gui.screens.Screen;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.screens.inventory.AnvilScreen;
import net.minecraft.client.multiplayer.ClientLevel;
import net.minecraft.client.particle.ParticleEngine;
import net.minecraft.client.renderer.blockentity.BlockEntityRendererProvider;
import net.minecraft.client.renderer.blockentity.BlockEntityRenderers;
import net.minecraft.client.resources.language.I18n;
import net.minecraft.core.BlockPos;
import net.minecraft.core.Direction;
import net.minecraft.core.particles.ParticleType;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.network.chat.Style;
import net.minecraft.world.InteractionHand;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.inventory.AnvilMenu;
import net.minecraft.world.inventory.MenuType;
import net.minecraft.world.item.BlockItem;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Items;
import net.minecraft.world.item.context.BlockPlaceContext;
import net.minecraft.world.item.enchantment.Enchantment;
import net.minecraft.world.item.enchantment.EnchantmentHelper;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.LevelReader;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.entity.BlockEntityType;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.phys.BlockHitResult;
import net.minecraft.world.phys.Vec3;
import net.minecraftforge.client.event.RegisterParticleProvidersEvent;
import net.minecraftforge.client.event.ScreenEvent;
import net.minecraftforge.event.entity.player.ItemTooltipEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.fml.ModList;
import net.minecraftforge.registries.ForgeRegistries;

public class EnchModuleClient {
  static BlockHitResult res = BlockHitResult.m_82426_(Vec3.f_82478_, Direction.NORTH, BlockPos.f_121853_);
  
  @SubscribeEvent
  public void tooltips(ItemTooltipEvent e) {
    Item i = e.getItemStack().m_41720_();
    List<Component> tooltip = e.getToolTip();
    if (i == Items.f_41863_) {
      tooltip.add(Component.m_237115_("info.apotheosis.cobweb").m_130940_(ChatFormatting.GRAY));
    } else if (i == Ench.Items.PRISMATIC_WEB.get()) {
      tooltip.add(Component.m_237115_("info.apotheosis.prismatic_cobweb").m_130940_(ChatFormatting.GRAY));
    } else if (i instanceof BlockItem) {
      Block block = ((BlockItem)i).m_40614_();
      ClientLevel clientLevel = (Minecraft.m_91087_()).f_91073_;
      if (clientLevel == null || (Minecraft.m_91087_()).f_91074_ == null)
        return; 
      Object object = new Object(this, (Level)clientLevel, (Player)(Minecraft.m_91087_()).f_91074_, InteractionHand.MAIN_HAND, e.getItemStack(), res);
      BlockState state = null;
      try {
        state = block.m_5573_((BlockPlaceContext)object);
      } catch (Exception ex) {
        EnchModule.LOGGER.trace(ex.getMessage());
        StackTraceElement[] trace = ex.getStackTrace();
        for (StackTraceElement traceElement : trace)
          EnchModule.LOGGER.trace("\tat " + traceElement); 
      } 
      if (state == null)
        state = block.m_49966_(); 
      float maxEterna = EnchantingStatRegistry.getMaxEterna(state, (Level)clientLevel, BlockPos.f_121853_);
      float eterna = EnchantingStatRegistry.getEterna(state, (Level)clientLevel, BlockPos.f_121853_);
      float quanta = EnchantingStatRegistry.getQuanta(state, (Level)clientLevel, BlockPos.f_121853_);
      float arcana = EnchantingStatRegistry.getArcana(state, (Level)clientLevel, BlockPos.f_121853_);
      float rectification = EnchantingStatRegistry.getQuantaRectification(state, (Level)clientLevel, BlockPos.f_121853_);
      int clues = EnchantingStatRegistry.getBonusClues(state, (Level)clientLevel, BlockPos.f_121853_);
      boolean treasure = ((IEnchantingBlock)state.m_60734_()).allowsTreasure(state, (LevelReader)clientLevel, BlockPos.f_121853_);
      if (eterna != 0.0F || quanta != 0.0F || arcana != 0.0F || rectification != 0.0F || clues != 0)
        tooltip.add(Component.m_237115_("info.apotheosis.ench_stats").m_130940_(ChatFormatting.GOLD)); 
      if (eterna != 0.0F)
        if (eterna > 0.0F) {
          tooltip.add(Component.m_237110_("info.apotheosis.eterna.p", new Object[] { String.format("%.2f", new Object[] { Float.valueOf(eterna) }), String.format("%.2f", new Object[] { Float.valueOf(maxEterna) }) }).m_130940_(ChatFormatting.GREEN));
        } else {
          tooltip.add(Component.m_237110_("info.apotheosis.eterna", new Object[] { String.format("%.2f", new Object[] { Float.valueOf(eterna) }) }).m_130940_(ChatFormatting.GREEN));
        }  
      if (quanta != 0.0F)
        tooltip.add(Component.m_237110_("info.apotheosis.quanta" + ((quanta > 0.0F) ? ".p" : ""), new Object[] { String.format("%.2f", new Object[] { Float.valueOf(quanta) }) }).m_130940_(ChatFormatting.RED)); 
      if (arcana != 0.0F)
        tooltip.add(Component.m_237110_("info.apotheosis.arcana" + ((arcana > 0.0F) ? ".p" : ""), new Object[] { String.format("%.2f", new Object[] { Float.valueOf(arcana) }) }).m_130940_(ChatFormatting.DARK_PURPLE)); 
      if (rectification != 0.0F)
        tooltip.add(Component.m_237110_("info.apotheosis.rectification" + ((rectification > 0.0F) ? ".p" : ""), new Object[] { String.format("%.2f", new Object[] { Float.valueOf(rectification) }) }).m_130940_(ChatFormatting.YELLOW)); 
      if (clues != 0)
        tooltip.add(Component.m_237110_("info.apotheosis.clues" + ((clues > 0) ? ".p" : ""), new Object[] { String.format("%d", new Object[] { Integer.valueOf(clues) }) }).m_130940_(ChatFormatting.DARK_AQUA)); 
      if (treasure)
        tooltip.add(Component.m_237115_("info.apotheosis.allows_treasure").m_130940_(ChatFormatting.GOLD)); 
      Set<Enchantment> blacklist = ((IEnchantingBlock)state.m_60734_()).getBlacklistedEnchantments(state, (LevelReader)clientLevel, BlockPos.f_121853_);
      if (blacklist.size() > 0) {
        tooltip.add(Component.m_237115_("info.apotheosis.filter").m_130938_(s -> s.m_178520_(5812428)));
        for (Enchantment ench : blacklist) {
          MutableComponent name = (MutableComponent)ench.m_44700_(1);
          name.m_7360_().clear();
          name.m_130938_(s -> s.m_178520_(5798058));
          tooltip.add(Component.m_237113_(" - ").m_7220_((Component)name).m_130938_(s -> s.m_178520_(5798058)));
        } 
      } 
    } else if (i == Items.f_42690_) {
      ItemStack stack = e.getItemStack();
      Map<Enchantment, Integer> enchMap = EnchantmentHelper.m_44831_(stack);
      if (enchMap.size() == 1) {
        Enchantment ench = enchMap.keySet().iterator().next();
        int lvl = ((Integer)enchMap.values().iterator().next()).intValue();
        if (!ModList.get().isLoaded("enchdesc") && 
          "apotheosis".equals(ForgeRegistries.ENCHANTMENTS.getKey(ench).m_135827_()))
          tooltip.add(Component.m_237115_(ench.m_44704_() + ".desc").m_130940_(ChatFormatting.DARK_GRAY)); 
        if (EnchConfig.showEnchantedBookMetadata) {
          EnchantmentInfo info = EnchModule.getEnchInfo(ench);
          Object[] args = new Object[4];
          args[0] = boolComp("info.apotheosis.discoverable", info.isDiscoverable());
          args[1] = boolComp("info.apotheosis.lootable", info.isLootable());
          args[2] = boolComp("info.apotheosis.tradeable", info.isTradeable());
          args[3] = boolComp("info.apotheosis.treasure", info.isTreasure());
          if (e.getFlags().m_7050_()) {
            tooltip.add(Component.m_237110_("%s ┇ %s ┇ %s ┇ %s", new Object[] { args[0], args[1], args[2], args[3] }).m_130940_(ChatFormatting.DARK_GRAY));
            tooltip.add(Component.m_237110_("info.apotheosis.book_range", new Object[] { Integer.valueOf(info.getMinPower(lvl)), Integer.valueOf(info.getMaxPower(lvl)) }).m_130940_(ChatFormatting.GREEN));
          } else {
            tooltip.add(Component.m_237110_("%s ┇ %s", new Object[] { args[2], args[3] }).m_130940_(ChatFormatting.DARK_GRAY));
          } 
        } 
      } 
    } 
  }
  
  @SubscribeEvent
  public void drawAnvilCostBlob(ScreenEvent.Render.Post e) {
    Screen screen = e.getScreen();
    if (screen instanceof AnvilScreen) {
      AnvilScreen anv = (AnvilScreen)screen;
      int level = ((AnvilMenu)anv.m_6262_()).m_39028_();
      if (level <= 0 || !((AnvilMenu)anv.m_6262_()).m_38853_(((AnvilMenu)anv.m_6262_()).m_266562_()).m_6657_())
        return; 
      List<Component> list = new ArrayList<>();
      list.add(Component.m_237113_(I18n.m_118938_("info.apotheosis.anvil_at", new Object[] { Integer.valueOf(level) })).m_130944_(new ChatFormatting[] { ChatFormatting.UNDERLINE, ChatFormatting.GREEN }));
      int expCost = EnchantmentUtils.getTotalExperienceForLevel(level);
      list.add(Component.m_237110_("info.apotheosis.anvil_xp_cost", new Object[] { Component.m_237113_("" + expCost).m_130940_(ChatFormatting.GREEN), 
              Component.m_237113_("" + level).m_130940_(ChatFormatting.GREEN) }));
      DrawsOnLeft.draw((AbstractContainerScreen)anv, e.getGuiGraphics(), list, anv.getGuiTop() + 28);
    } 
  }
  
  private static Component boolComp(String key, boolean flag) {
    return (Component)Component.m_237115_(key + key).m_130948_(Style.f_131099_.m_178520_(flag ? 1083408 : 11146774));
  }
  
  public static void init() {
    BlockEntityRenderers.m_173590_(BlockEntityType.f_58928_, net.minecraft.client.renderer.blockentity.EnchantTableRenderer::new);
    MenuScreens.m_96206_((MenuType)Apoth.Menus.ENCHANTING_TABLE.get(), dev.shadowsoffire.apotheosis.ench.table.ApothEnchantScreen::new);
    MenuScreens.m_96206_((MenuType)Apoth.Menus.LIBRARY.get(), dev.shadowsoffire.apotheosis.ench.library.EnchLibraryScreen::new);
  }
  
  @SubscribeEvent
  public static void particleFactories(RegisterParticleProvidersEvent e) {
    e.registerSpriteSet((ParticleType)Apoth.Particles.ENCHANT_FIRE.get(), net.minecraft.client.particle.EnchantmentTableParticle.Provider::new);
    e.registerSpriteSet((ParticleType)Apoth.Particles.ENCHANT_WATER.get(), net.minecraft.client.particle.EnchantmentTableParticle.Provider::new);
    e.registerSpriteSet((ParticleType)Apoth.Particles.ENCHANT_SCULK.get(), net.minecraft.client.particle.EnchantmentTableParticle.Provider::new);
    e.registerSpriteSet((ParticleType)Apoth.Particles.ENCHANT_END.get(), net.minecraft.client.particle.EnchantmentTableParticle.Provider::new);
  }
}
